;; Here, we do not extract an iterator for each function as
;; in the expression problem example.
;; A second difference is that the business function take the main functions 
;; as arguments to avoid circularity between modules.

(defvar f1        "freeVars")

(defvar c1        "Var")
(defvar c2        "App")
(defvar c3        "Lam")
(defvar c4        "Pi")
(defvar c5        "Let")
(defvar c6        "Kind")

(defvar mod       "CubeExpr")

(defvar f1c1      "freeVarsVar")
(defvar f1c2      "freeVarsApp")
(defvar f1c3      "freeVarsLam")
(defvar f1c4      "freeVarsPi")
(defvar f1c5      "freeVarsLet")
(defvar f1c6      "freeVarsKind")

(defvar varmod    "VarMod")
(defvar appmod    "AppMod")
(defvar lammod    "LamMod")
(defvar pimod     "PiMod")
(defvar letmod    "LetMod")
(defvar kindmod   "KindMod")
(defvar climod    "Client")

(defvar f2 "alphaEq")

(defvar f2c1 "alphaEqVar")
(defvar f2c2 "alphaEqApp")
(defvar f2c3 "alphaEqLam")
(defvar f2c4 "alphaEqPi")
(defvar f2c5 "alphaEqLet")
(defvar f2c6 "alphaEqKind")

;; 1) FreeVars (the script is organised by case in the data-type)

;; freeVars - case Var
(haskell-refac-exhibitFunction f1 c1 f1c1 mod)
(haskell-refac-generalise f1 c1 f1c1 mod "0" "x" "Curried" "OtherType")
(haskell-refac-makeGlobalOfLocalIn f1 f1c1 mod)
(haskell-refac-moveDefBetweenModules f1c1 mod varmod)

;; freeVars - case App
(haskell-refac-exhibitFunction f1 c2 f1c2 mod)
(haskell-refac-generalise f1 c2 f1c2 mod "1" "right" "Curried" "OtherType")
(haskell-refac-generalise f1 c2 f1c2 mod "0" "left" "Curried" "OtherType")
(haskell-refac-makeGlobalOfLocalIn f1 f1c2 mod)
(haskell-refac-generaliseIdent f1c2 mod f1 "fv")
(haskell-refac-moveDefBetweenModules f1c2 mod appmod)

;; freeVars - case Lam
(haskell-refac-exhibitFunction f1 c3 f1c3 mod)
(haskell-refac-generalise f1 c3 f1c3 mod "2" "e" "Curried" "OtherType")
(haskell-refac-generalise f1 c3 f1c3 mod "1" "t" "Curried" "OtherType")
(haskell-refac-generalise f1 c3 f1c3 mod "0" "i" "Curried" "OtherType")
(haskell-refac-makeGlobalOfLocalIn f1 f1c3 mod)
(haskell-refac-generaliseIdent f1c3 mod f1 "fv")
(haskell-refac-moveDefBetweenModules f1c3 mod lammod)

;; freeVars - case Pi
(haskell-refac-exhibitFunction f1 c4 f1c4 mod)
(haskell-refac-generalise f1 c4 f1c4 mod "2" "t" "Curried" "OtherType")
(haskell-refac-generalise f1 c4 f1c4 mod "1" "k" "Curried" "OtherType")
(haskell-refac-generalise f1 c4 f1c4 mod "0" "i" "Curried" "OtherType")
(haskell-refac-makeGlobalOfLocalIn f1 f1c4 mod)
(haskell-refac-generaliseIdent f1c4 mod f1 "fv")
(haskell-refac-moveDefBetweenModules f1c4 mod pimod)

;; freeVars - cas Let : nothing to do.

;; freeVars - case Kind
(haskell-refac-exhibitFunction f1 c6 f1c6 mod)
(haskell-refac-makeGlobalOfLocalIn f1 "one" mod) ;; replace by demote -- this step is necessary only because there is a bug in HaRe
(haskell-refac-makeGlobalOfLocalIn f1 "nil" mod) ;; replace by demote
(haskell-refac-makeGlobalOfLocalIn f1 f1c6 mod)
(haskell-refac-generaliseIdent f1c6 mod "nil" "nil")
(haskell-refac-moveDefBetweenModules f1c6 mod kindmod) ;; replace by demote


;; 2) alphaEq (the script is organized by step in the transformation)

;; Introduce new defs
(haskell-refac-exhibitFunction f2 c1 f2c1 mod)
(haskell-refac-exhibitFunction f2 c2 f2c2 mod)
(haskell-refac-exhibitFunction f2 c3 f2c3 mod)
(haskell-refac-exhibitFunction f2 c4 f2c4 mod)
(haskell-refac-exhibitFunction f2 c5 f2c5 mod)
(haskell-refac-exhibitFunction f2 c6 f2c6 mod)

;; generalisations and liftings
(haskell-refac-generalise2 f2 c1 f2c1 mod "0" "s'" "Curried" "OtherType" "1")
(haskell-refac-generalise2 f2 c1 f2c1 mod "0" "s" "Curried" "OtherType" "0")

(haskell-refac-generalise2 f2 c2 f2c2 mod "1" "a'" "Curried" "OtherType" "1")
(haskell-refac-generalise2 f2 c2 f2c2 mod "0" "f'" "Curried" "OtherType" "1")
(haskell-refac-generalise2 f2 c2 f2c2 mod "1" "a" "Curried" "OtherType" "0")
(haskell-refac-generalise2 f2 c2 f2c2 mod "0" "f" "Curried" "OtherType" "0")

(haskell-refac-generalise2 f2 c3 f2c3 mod "2" "e'" "Curried" "OtherType" "1")
(haskell-refac-generalise2 f2 c3 f2c3 mod "1" "t'" "Curried" "OtherType" "1")
(haskell-refac-generalise2 f2 c3 f2c3 mod "0" "s'" "Curried" "OtherType" "1")
(haskell-refac-generalise2 f2 c3 f2c3 mod "2" "e" "Curried" "OtherType" "0")
(haskell-refac-generalise2 f2 c3 f2c3 mod "1" "t" "Curried" "OtherType" "0")
(haskell-refac-generalise2 f2 c3 f2c3 mod "0" "s" "Curried" "OtherType" "0")

(haskell-refac-generalise2 f2 c4 f2c4 mod "2" "t'" "Curried" "OtherType" "1")
(haskell-refac-generalise2 f2 c4 f2c4 mod "1" "k'" "Curried" "OtherType" "1")
(haskell-refac-generalise2 f2 c4 f2c4 mod "0" "s'" "Curried" "OtherType" "1")
(haskell-refac-generalise2 f2 c4 f2c4 mod "2" "t" "Curried" "OtherType" "0")
(haskell-refac-generalise2 f2 c4 f2c4 mod "1" "k" "Curried" "OtherType" "0")
(haskell-refac-generalise2 f2 c4 f2c4 mod "0" "s" "Curried" "OtherType" "0")

(haskell-refac-generalise2 f2 c5 f2c5 mod "3" "b'" "Curried" "OtherType" "1")
(haskell-refac-generalise2 f2 c5 f2c5 mod "2" "e'" "Curried" "OtherType" "1")
(haskell-refac-generalise2 f2 c5 f2c5 mod "1" "t'" "Curried" "OtherType" "1")
(haskell-refac-generalise2 f2 c5 f2c5 mod "0" "s'" "Curried" "OtherType" "1")
(haskell-refac-generalise2 f2 c5 f2c5 mod "3" "b" "Curried" "OtherType" "0")
(haskell-refac-generalise2 f2 c5 f2c5 mod "2" "e" "Curried" "OtherType" "0")
(haskell-refac-generalise2 f2 c5 f2c5 mod "1" "t" "Curried" "OtherType" "0")
(haskell-refac-generalise2 f2 c5 f2c5 mod "0" "s" "Curried" "OtherType" "0")

(haskell-refac-generalise2 f2 c6 f2c6 mod "0" "k'" "Curried" "OtherType" "1")
(haskell-refac-generalise2 f2 c6 f2c6 mod "0" "k" "Curried" "OtherType" "0")

(haskell-refac-makeGlobalOfLocalIn f2  f2c1 mod)
(haskell-refac-makeGlobalOfLocalIn f2  f2c2 mod)
(haskell-refac-makeGlobalOfLocalIn f2  f2c3 mod)
(haskell-refac-makeGlobalOfLocalIn f2  f2c4 mod)
(haskell-refac-makeGlobalOfLocalIn f2  f2c5 mod)
(haskell-refac-makeGlobalOfLocalIn f2  f2c6 mod)

(haskell-refac-generaliseIdent f2c2 mod f2 "aeq")
(haskell-refac-generaliseIdent f2c3 mod f2 "aeq")
(haskell-refac-generaliseIdent f2c4 mod f2 "aeq")
(haskell-refac-generaliseIdent f2c5 mod f2 "aeq")

(haskell-refac-generaliseIdent f2c3 mod "substVar" "sv")
(haskell-refac-generaliseIdent f2c4 mod "substVar" "sv")
(haskell-refac-generaliseIdent f2c5 mod "substVar" "sv")

;; move business functions to the appropriate modules
(haskell-refac-moveDefBetweenModules f2c1 mod varmod)
(haskell-refac-moveDefBetweenModules f2c2 mod appmod)
(haskell-refac-moveDefBetweenModules f2c3 mod lammod)
(haskell-refac-moveDefBetweenModules f2c4 mod pimod)
(haskell-refac-moveDefBetweenModules f2c5 mod letmod)
(haskell-refac-moveDefBetweenModules f2c6 mod kindmod)



